
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>浅析JSONP之解决ajax跨域问题_AJAX相关 / iVAN</title>

    <meta name="description" content="浅析JSONP之解决ajax跨域问题_AJAX相关 JSON和JSONP JSONP和JSON好像啊,他们之间有什么联系吗? JSON(JavaScript Object Notation) 是一种轻量级的数据交换格式.对于JSON大家应该是很了解了吧,不是很清楚的朋友可以去json.org上了解下,简单易懂. JSONP是JSON with Padding的略称.它是一个非官方的协议,它允许在服务器端集成Script tags返回至客户端,通过javascript callback的形式实现跨域访问(这仅仅是JSONP简单的实现形式). JSO">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">浅析JSONP之解决ajax跨域问题_AJAX相关</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<p>JSON和JSONP</p>
<p>　　JSONP和JSON好像啊，他们之间有什么联系吗？</p>
<p>　　JSON(JavaScript Object Notation) 是一种轻量级的数据交换格式。对于JSON大家应该是很了解了吧，不是很清楚的朋友可以去json.org上了解下，简单易懂。</p>
<p>　　JSONP是JSON with Padding的略称。它是一个非官方的协议，它允许在服务器端集成Script tags返回至客户端，通过javascript callback的形式实现跨域访问（这仅仅是JSONP简单的实现形式）。</p>
<p>　　JSONP就像是JSON+Padding一样(Padding这里我们理解为填充)， 我们先看下面的小例子然后再详细介绍。</p>
<p>同源策略</p>
<p>　　为什么会出这样的错误呢？这是因为所有支持Javascript的浏览器都会使用同源策略这个安全策略。看看百度的解释：</p>
<p>　　同源策略，它是由Netscape提出的一个著名的安全策略。现在所有支持JavaScript 的浏览器都会使用这个策略。所谓同源是指，域名，协议，端口相同。当一个浏览器的两个tab页中分别打开来 百度和谷歌的页面当一个百度浏览器执行一个脚本的时候会检查这个脚本是属于哪个页面的，即检查是否同源，只有和百度同源的脚本才会被执行。</p>
<p>　　这就是引起为何取不到数据的原因了，那如何才能解决跨域的问题呢？没错，我们现在可以进入正题，来了解下什么是JSONP了。</p>
<p>跨域的简单原理</p>
<p>　　光看定义还不是很明白，那首先我们先来手动做个简单易懂的小测试。新建一个asp.net的web程序，添加sample.html网页和一个test.js文件，代码如下：</p>
<p><strong>sample.html的代码：</strong></p>
<pre>
 &lt;!DOCTYPE html PUBLIC "-//WC//DTD XHTML . Transitional//EN" "http://www.w.org/TR/xhtml/DTD/xhtml-transitional.dtd"&gt;
 &lt;html xmlns="http://www.w.org//xhtml" &gt;
 &lt;head&gt;
   &lt;title&gt;test&lt;/title&gt;
   &lt;script type="text/javascript" src="test.js"&gt;&lt;/script&gt;
 &lt;/head&gt;
 &lt;body&gt;
 &lt;/body&gt;
 &lt;/html&gt;</pre>
<p><strong>test.js的代码：</strong></p>
<pre>
alert("success");</pre>
<p>　　打开sample.html后会跳出"success”这样的这样的信息框，这似乎并不能说明什么， 跨域问题到底怎么解决呢？好，现在我们模拟下非同源的环境，刚才我们不是已经用Visual Studio新建了一个Web程序吗(这里我们叫A程序)，现在我们再打开一个新的Visual Studio再新建一个Web程序(B程序)，将我们的之前的test.js文件从A程序中移除然后拷贝到B程序中。两个程序都运行起来后，Visual Studio会启动内置服务器，假设A程序是localhost:20001,B程序是localhost:20002，这就模拟了一个非同源的环境了(虽然域名相同但端口号不同，所以是非同源的)。</p>
<p>　　OK，我们接下来应该改下sample.html里的代码，因为test.js文件在B程序上了，url也就变成了localhost:20002。</p>
<p><strong>sample.html部分代码：</strong></p>
<pre>
&lt;script type="text/javascript" src="http://localhost:20002/test.js"&gt;&lt;/script&gt;</pre>
<p>　　请保持AB两个Web程序的运行状态，当你再次刷新localhost:20001/sample.html的时候，和原来一样跳出了"success"的对话框，是的，成功访问到了非同源的localhost:20002/test.js这个所谓的远程服务了。到了这一步，相信大家应该已经大概明白如何跨域访问了的原理了。</p>
<p>　　&lt;script&gt;标签的src属性并不被同源策略所约束，所以可以获取任何服务器上脚本并执行。</p>
<p>JSONP的实现模式--CallBack</p>
<p>　　刚才的小例子讲解了跨域的原理，我们回上去再看看JSONP的定义说明中讲到了javascript callback的形式。那我们就来修改下代码，如何实现JSONP的javascript callback的形式。</p>
<p>程序A中sample的部分代码：</p>
<pre>
 &lt;script type="text/javascript"&gt;
 //回调函数
 function callback(data) {
   alert(data.message);
 }
 &lt;/script&gt;
 &lt;script type="text/javascript" src="http://localhost:20002/test.js"&gt;&lt;/script&gt;</pre>
<p>程序B中test.js的代码：</p>
<p>//调用callback函数，并以json数据形式作为阐述传递，完成回调</p>
<pre>
callback({message:"success"}); </pre>
<p>　　这其实就是JSONP的简单实现模式，或者说是JSONP的原型：创建一个回调函数，然后在远程服务上调用这个函数并且将JSON 数据形式作为参数传递，完成回调。</p>
<p>　　将JSON数据填充进回调函数，这就是JSONP的JSON+Padding的含义吧。</p>
<p>　　一般情况下，我们希望这个script标签能够动态的调用，而不是像上面因为固定在html里面所以没等页面显示就执行了，很不灵活。我们可以通过javascript动态的创建script标签，这样我们就可以灵活调用远程服务了。</p>
<p><strong>程序A中sample的部分代码：</strong></p>
<pre>
 &lt;script type="text/javascript"&gt;
   function callback(data) {
     alert(data.message);
   }
   //添加&lt;script&gt;标签的方法
   function addScriptTag(src){
   var script = document.createElement('script');
     script.setAttribute("type","text/javascript");
     script.src = src;
     document.body.appendChild(script);
   } 

   window.onload = function(){
     addScriptTag("http://localhost:/test.js");
   }
 &lt;/script&gt;</pre>
<p>　　程序B的test.js代码不变，我们再执行下程序，是不是和原来的一样呢。如果我们再想调用一个远程服务的话，只要添加addScriptTag方法，传入远程服务的src值就可以了。这里说明下为什么要将addScriptTag方法放入到window.onload的方法里，原因是addScriptTag方法中有句document.body.appendChild(script);，这个script标签是被添加到body里的，由于我们写的javascript代码是在head标签中，document.body还没有初始化完毕呢，所以我们要通过window.onload方法先初始化页面，这样才不会出错。</p>
<p>　　上面的例子是最简单的JSONP的实现模型，不过它还算不上一个真正的JSONP服务。我们来看一下真正的JSONP服务是怎么样的，比如Google的ajax搜索接口：http://ajax.googleapis.com/ajax/services/search/web?v=1.0&amp;q=?&amp;callback=?</p>
<p>　　q=?这个问号是表示你要搜索的内容，最重要的是第二个callback=?这个是正如其名表示回调函数的名称，也就是将你自己在客户端定义的回调函数的函数名传送给服务端，服务端则会返回以你定义的回调函数名的方法，将获取的json数据传入这个方法完成回调。有点罗嗦了，还是看看实现代码吧：</p>
<pre>
 &lt;script type="text/javascript"&gt;
   //添加&lt;script&gt;标签的方法
   function addScriptTag(src){
     var script = document.createElement('script');
     script.setAttribute("type","text/javascript");
     script.src = src;
     document.body.appendChild(script);
   }
   window.onload = function(){
     //搜索apple，将自定义的回调函数名result传入callback参数中
     addScriptTag("http://ajax.googleapis.com/ajax/services/search/web?v=.&amp;q=apple&amp;callback=result");
   }
   //自定义的回调函数result
   function result(data) {
     //我们就简单的获取apple搜索结果的第一条记录中url数据
     alert(data.responseData.results[].unescapedUrl);
   }
 &lt;/script&gt;</pre>
<p>像这样的JSONP服务还有很多(以下信息来自使用 JSONP 实现跨域通信，第 1 部分: 结合 JSONP 和 jQuery 快速构建强大的 mashup)：</p>
<p>Digg API：来自 Digg 的头条新闻：</p>
<p>　　http://services.digg.com/stories/top?appkey=http%3A%2F%2Fmashup.com&amp;type=javascript&amp;callback=?</p>
<p>Geonames API：邮编的位置信息：</p>
<p>　　http://www.geonames.org/postalCodeLookupJSON?postalcode=10504&amp;country=US&amp;callback=?</p>
<p>Flickr JSONP API：载入最新猫的图片：</p>
<p>　　http://api.flickr.com/services/feeds/photos_public.gne?tags=cat&amp;tagmode=any&amp;format=json&amp;jsoncallback=?</p>
<p>Yahoo Local Search API：在邮编为 10504 的地区搜索比萨：</p>
<p>　　http://local.yahooapis.com/LocalSearchService/V3/localSearch?appid=YahooDemo&amp;query=pizza&amp;zip=10504&amp;results=2&amp;output=json&amp;callback=?</p>
<p>　　接下来我们自己来创建一个简单的远程服务，实现和上面一样的JSONP服务。还是利用Web程序A和程序B来做演示，这次我们在程序B上创建一个MyService.ashx文件。</p>
<p><strong>程序B的MyService.ashx代码：</strong></p>
<pre>
 public class MyService : IHttpHandler
   {
     public void ProcessRequest(HttpContext context)
     {
       //获取回调函数名
       string callback = context.Request.QueryString["callback"];
       //json数据
       string json = "{\"name\":\"chopper\",\"sex\":\"man\"}"; 

       context.Response.ContentType = "application/json";
       //输出：回调函数名(json数据)
       context.Response.Write(callback + "(" + json + ")");
     } 

     public bool IsReusable
     {
       get
       {
         return false;
       }
     }
   }
</pre>
<p><strong>程序A的sample代码中的调用：</strong></p>
<pre>
 &lt;script type="text/javascript"&gt;   function addScriptTag(src){
     var script = document.createElement('script');
     script.setAttribute("type","text/javascript");
     script.src = src;
     document.body.appendChild(script);
   }
    window.onload = function(){
     //调用远程服务     addScriptTag("http://localhost:/MyService.ashx?callback=person");
   }
   //回调函数person   function person(data) {
     alert(data.name + " is a " + data.sex);
   }
 &lt;/script&gt;　　</pre>
<p>　　这就完成了一个最基本的JSONP服务调用了，是不是很简单，下面我们来了解下JQuery是如何调用JSONP的。</p>
<p>jQuery对JSONP的实现</p>
<p>　　jQuery框架也当然支持JSONP，可以使用$.getJSON(url,[data],[callback])方法(详细可以参考http://api.jquery.com/jQuery.getJSON/)。那我们就来修改下程序A的代码，改用jQuery的getJSON方法来实现(下面的例子没用用到向服务传参，所以只写了getJSON(url,[callback]))：</p>
<pre>
&lt;script type="text/javascript" src="http://code.jquery.com/jquery-latest.js"&gt;&lt;/script&gt; &lt;script type="text/javascript"&gt;
 $.getJSON("http://localhost:20002/MyService.ashx?callback=?",
function(data){     alert(data.name + " is a a" + data.sex);   });
&lt;/script&gt;</pre>
<p>　　结果是一样的，要注意的是在url的后面必须添加一个callback参数，这样getJSON方法才会知道是用JSONP方式去访问服务，callback后面的那个问号是内部自动生成的一个回调函数名。这个函数名大家可以debug一下看看，比如jQuery17207481773362960666_1332575486681。</p>
<p>　　当然，加入说我们想指定自己的回调函数名，或者说服务上规定了固定回调函数名该怎么办呢？我们可以使用$.ajax方法来实现(参数较多，详细可以参考http://api.jquery.com/jQuery.ajax)。先来看看如何实现吧：</p>
<pre>
&lt;script type="text/javascript" src="http://code.jquery.com/jquery-latest.js"&gt;&lt;/script&gt;
&lt;script type="text/javascript"&gt;
 $.ajax({     url:"http://localhost:20002/MyService.ashx?callback=?",
dataType:"jsonp",     jsonpCallback:"person",
success:function(data){
alert(data.name + " is a a" + data.sex);     }  });
&lt;/script&gt;</pre>
<p>　　没错，jsonpCallback就是可以指定我们自己的回调方法名person，远程服务接受callback参数的值就不再是自动生成的回调名，而是person。dataType是指定按照JSOPN方式访问远程服务。</p>
<p>利用jQuery可以很方便的实现JSONP来进行跨域访问。先暂时写到这吧。后续还有更新，请持续关注，谢谢。</p>
<p>以上是小编为您精心准备的的内容，在的博客、问答、公众号、人物、课程等栏目也有的相关内容，欢迎继续使用右上角搜索按钮进行搜索ajax跨域请求jsonp<br />
                    ，                ajax_onp跨域访问<br />
                                    ajax_sonp<br />
                                    ajax jsonp 跨域、ajax跨域请求 jsonp、ajax jsonp post 跨域、ajax jsonp跨域访问、ajax 跨域上传 jsonp，以便于您获取更多的相关知识。</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-08 14:28:22</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.iamivan.net/tag/ajax%e8%b7%a8%e5%9f%9f%e8%af%b7%e6%b1%82jsonp/" title="ajax跨域请求jsonp">ajax跨域请求jsonp</a>, <a href="https://www.iamivan.net/tag/ajax_onp%e8%b7%a8%e5%9f%9f%e8%ae%bf%e9%97%ae/" title="ajax&lowbar;onp跨域访问">ajax&lowbar;onp跨域访问</a>, <a href="https://www.iamivan.net/tag/ajax_sonp/" title="ajax&lowbar;sonp">ajax&lowbar;sonp</a>        </div> -->
	</section>
	
	

		<div id="similar">

		<h3>浅析JSONP之解决ajax跨域问题_AJAX相关的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/Mg31oEM.html" rel="bookmark">服务端配置实现AJAX跨域请求&lowbar;AJAX相关</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				一直以为AJAX跨域是无法逾越的鸿沟,最近发现原来在服务端可以通过发送header信息来允许AJAX跨域请求. PHP代码示例: 复制代码 代码如下: header('Access-Control-Allow-Origin:*'); header('Access-Control-Allow-Headers:X-Requested-With'); 经过测试,webkit内核的浏览器成功实现跨域请求. IE一如既往的不支持~看来只能在移动端享用这一强大功能了 另外,需要注意的是,第一行配置中的*表示			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zDYN0rb.html" rel="bookmark">探秘ajax跨域请求&lowbar;AJAX相关</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				前言 ajax,用苍白的话赞扬:很好. 我们可以使用ajax实现异步获取数据,减少服务器运算时间,大大地改善用户体验:我们可以使用ajax实现小系统组合大系统:我们还可以使用ajax实现前端的优化.(好一个排比) 虽然ajax很好,但在使用起来也会有一定的限制,出于安全考虑,不允许跨域通信.如果尝试从不同的域请求数据,会出现安全错误.(下面例子1可以直观看出) 同源策略限制 同源策略阻止从一个域上加载的脚本获取或操作另一个域上的文档属性.也就是说,受到请求的 URL 的域必须与当前 Web 页面			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MyP6xPb.html" rel="bookmark">深入浅析Jsonp解决ajax跨域问题</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				一.介绍 最近跨域问题比较多,而且自己刚好也看到这一块,就总结了一下,关于JSONP的东西百度的话东西确实很多,很多人都是复制别人的,如此下去,其实找的资料就那么几份,关键是我还看不懂,可能是能力问题吧,自己经过很多尝试,所以总结了一下,终究还是弄懂了皮毛.注意一点是,这里是用Jsonp解决ajax的跨域问题,具体的实现其实不是ajax. 1.同源策略 浏览器有一个很重要的概念--同源策略(Same-Origin Policy).所谓同源是指,域名,协议,端口相同.不同源的客户端脚本(JavaS			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MR1DLkb.html" rel="bookmark">浅析JSONP解决Ajax跨域访问问题的思路详解&lowbar;AJAX相关</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				前几天,工作上有一新需求,需要前端web页面异步调用后台的Webservice方法返回信息.实现方法有多种,本例采用jQuery+Ajax,完成后,在本地调试了一切ok,但是部署到服务器上以后就出现问题了,后台服务调用没有响应,怎么回事?代码没怎么改动,唯一修改的地方就是jQuery的ajax方法中的url地址.难道是这里的问题,经过检查和调试,发现原来是同源策略在作怪,我们知道,JavaScript或jQuery是在Web前端开发中经常使用的动态脚本技术.在JavaScript中,有一个很重要			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pL58aWz.html" rel="bookmark">JSONP跨域GET请求解决Ajax跨域访问问题&lowbar;json</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				前几天,工作上有一新需求,需要前端web页面异步调用后台的Webservice方法返回信息.实现方法有多种,本例采用jQuery+Ajax,完成后,在本地调试了一切ok,但是部署到服务器上以后就出现问题了,后台服务调用没有响应,怎么回事?代码没怎么改动,唯一修改的地方就是jQuery的ajax方法中的url地址.难道是这里的问题,经过检查和调试,发现原来是同源策略在作怪,我们知道,JavaScript或jQuery是在Web前端开发中经常使用的动态脚本技术.在JavaScript中,有一个很重要			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pXK2w5M.html" rel="bookmark">JSONP解决AJAX跨域代码示例</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				有两个子域名,a.xx.com和b.xx.com,现在我在a.xx.com一个页面中发送ajax请求b.xx.com一个控制器中的方法,希望得到返回数据,但是返回状态302,应该是跨域问题没有解决. 解决ajax跨域问题的一个办法是使用jsonp,jquery封装了ajax方法和getJason方法,工作中也遇到了跨域问题,记录一下jsonp的用法和示例. (function($) { var url = '/scripts/jquery4u-sites.json?callback=?';  			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zO9xYkM.html" rel="bookmark">完美解决ajax跨域请求下parsererror的错误</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				ajax请求报parsererror错误是很宽泛的概念,很多情况下都报这个错, 在很多时候,即使ajax提交.返回都正常 XMLHttpRequest.status=200  (正常响应) XMLHttpRequest.readyState=4 (正常接收) ajax也会提示一个parseerror的错误. 出现这个错误,大都是不良书写习惯,或者语法不当造成的. 关于ajax的错误,请使用: error:function(XMLHttpRequest, textStatus, errorThro			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MWDLwXp.html" rel="bookmark">解决ajax跨域请求数据cookie丢失问题</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				前端: 以jquery为例: 需要加入 复制代码 代码如下: xhrFields: {             withCredentials: true         },         crossDomain: true, $.ajax({         type: postType,         url: url,         data: postData || '',         xhrFields: {             withCredentials: tru			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MAkwrKz.html" rel="bookmark">使用JSONP解决Ajax跨域访问问题</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				前几天,工作上有一新需求,需要前端web页面异步调用后台的Webservice方法返回信息.实现方法有多种,本例采用 jQuery+Ajax,完成后,在本地调试了一切ok,但是部署到服务器上以后就出现问题了,后台服务调用没有响应,怎么回事?代码没怎么改动,唯一修改的地方就是jQuery的ajax方法中的url地址.难道是这里的问题,经过检查和调试,发现原来是同源策略在作怪,我们知道,JavaScript 或jQuery是在Web前端开发中经常使用的动态脚本技术.在JavaScript中,有一个很			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/LzJOP6b.html" rel="bookmark" class="title">Web表单设计：表单结构</a>
					<div>
						你是否曾为表单设计感到过沮丧或不知所措呢?接下来三篇文章,希望能彻底改变你的看法,真正爱上Web表单设计.首先感谢Luke Wroblewski的帮助,让我有机会细心品味设计表单的乐趣.总体来说,We ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/0zGnkep.html" rel="bookmark" class="title">浅析：了解竞价排名的四个基础建议</a>
					<div>
						虽说现在大部分企业和网站建设从业人员对于&quot;竞价&quot;都抱怨太过烧钱,简直是个无底洞.但是骂归骂,大家还是在用.没办法,谁叫百度现在市场占有率那么强悍呢,就算是新兴崛起的360,它也得做 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Lp5xZRM.html" rel="bookmark" class="title">SEO只是成功者的工具 从seo向ceo转型</a>
					<div>
						seo在中国发展至今也有10余年,有人发财致富.名利双收,有人穷迫廖倒,温饱都成问题,有人还在seo的最基层摸索,也有人从seo成功转型ceo ,有人把seo当职业目标,有人把seo当做成功的手段,就 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/qbaRJnM.html" rel="bookmark" class="title">提高网站性能中网站服务器的改进</a>
					<div>
						在本系列的第一节中,讲了 提高网站性能中网站&quot;内容&quot;有关的10条原则 .除了在网站在内容上的改进外,在网站服务器端上也有需要注意和改进的地方,它们包括: 使用内容分发网络 为文件头 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/5zOBmkp.html" rel="bookmark" class="title">采用&OpenCurlyDoubleQuote;独占&rdquo;的方式给数据库设置密码</a>
					<div>
						大家都知道,数据库的安全性是很重要的,它直接影响到数据库的广泛应用.用户可以采用任意一种方法来保护数据库应用程序,也可以将几种方法结合起来使用.利用Access数据库自身提供的加密功能及其他保护方法是 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/xpnl5Ab.html" rel="bookmark" class="title">Delphi中的TWebBrowser与MSHTML&lpar;4&rpar;&colon;location、history、screen、navigator</a>
					<div>
						{location 对象:} reload //重新加载当前文档 replace //用新的文档替换当前文档 assign //加载新文档 href //设置或返回完整的 URL protocol / ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MvKPK9p.html" rel="bookmark" class="title">用PS滤镜制作彩色羽毛的技巧</a>
					<div>
						最终效果 1.新建一个 400PX * 400PX的文件,背景填充黑色 2.再新建一个图层,用矩形选取工具绘制选区如图1,然后按 Alt + Ctrl + D 羽化数值为3,然后填充为白色.按Ctrl ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pXj62Ab.html" rel="bookmark" class="title">ESC键的秒用</a>
					<div>
						我关注了很多系统快捷键的妙用之类的文章,都没发现ESC键的秒用,而我以前也没注意到这方面的.最近有人跟我说ESC键的秒用我才知道原因ESC还有这么多神奇的用途啊. 1 个人感觉ESC最实用的功能 我们 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z42L3JM.html" rel="bookmark" class="title">解析黑客入侵常用的手段</a>
					<div>
						  1.密码入侵 所谓密码入侵就是指用一些软件解开加密文档,但是,许多忠于此术的黑客并不采用这种方法而是用一种可以绕开或辟蔽密码保护的程序.对于那些可以解开或屏蔽密码保护的程序通常被称为Crack.  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M0W3v6b.html" rel="bookmark" class="title">U盘拒绝格式化的原因</a>
					<div>
						  1.主要有中毒(包括中毒后的乱搞) 2.U盘读写时插拔(特别是写数据的时候) 3. 正常格式化U盘后出现&quot;可用空间和未用空间都是0字节 4.双击(或右键)打开时弹出对话框让格式化 5.点 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bQNd0KM.html" rel="bookmark" class="title">Win7系统文件修复工具SFC使用说明</a>
					<div>
						在Win7系统的使用过程中,有时我们会发现系统中存在着一些损坏或者丢失的系统文件,对于这部分系统文件,我们该怎么解决呢?是否可以使用系统文件检查器工具(SFC.exe)来进行检测和修复.一起看看具体操 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pn7Aqoz.html" rel="bookmark" class="title">javascript检测浏览器flash版本的实现代码&lowbar;javascript技巧</a>
					<div>
						记录: 复制代码 代码如下: (function(){ ver has=0, ver=0; try{ has=new ActiveXObject('ShockwaveFlash.ShockwaveFl ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p5Negnz.html" rel="bookmark" class="title">c语言如何把链表数据写入文件？</a>
					<div>
						问题描述 c语言如何把链表数据写入文件? 在写一个通讯录管理系统,然后要把联系人的信息结构体放到链表中,然后将链表里的信息写入文件中,下次打开时还能从该文件读出数据. 链表头指针TEL,结构体中有na ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b3282gz.html" rel="bookmark" class="title">大师们都是怎么撑场面的（转）</a>
					<div>
						要说现在互联网界最火的概念,微信称第二,估计没有其它的应用敢称第一.在学校周边的烤红薯阿姨都在用微信预订时,作为一名有理想.有道德.有追求.有见识的有为青年或中老年,成为一名微信营销届大师应该成为我们 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pPPee8p.html" rel="bookmark" class="title">ubuntu 如何更换软件源</a>
					<div>
						1.ubuntu 如何更换软件源 1.1确保系统已经连入互联网. 1.2在终端中修改服务器列表.  $sudo cp /etc/apt/sources.list /etc/apt/sources.li ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/ba7mRgp.html" rel="bookmark" class="title">修改word2010默认模板</a>
					<div>
						呵呵,因为自己写博客的习惯.经常有几句话是写在博客的首页,所以就想偷懒一下.不想每一次都手动添加,这不才有了这篇文章. 首先.我们先把自己的模板设计好,如图: 然后点击&quot;文件&quot;-& ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M94wokb.html" rel="bookmark" class="title">DT科技评论：第8期</a>
					<div>
						DT科技评论 Data Technology Review 第 8 期           人民网研究院,阿里云研究中心 本期目录 美国五大科技巨头联手成立&quot;AI伙伴关系&quot;组织,建 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MYX2P6b.html" rel="bookmark" class="title">三星计划手机销量三年内超过诺基亚</a>
					<div>
						12月28日消息,举国外媒体报道,三星电子计划在2011年提高在中国和越南的手机产量.三星电子对2011年的手机市场非常乐观,特别是对这两个新兴市场,主要原因是这些地区对智能手机和平板电脑需求非常旺盛 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zJq664p.html" rel="bookmark" class="title">关于&OpenCurlyDoubleQuote;下载&rdquo;的源码</a>
					<div>
						问题描述 我想要一个.NET关于&quot;下载&quot;的源代码,简单实用 解决方案 解决方案二:关于下载?什么意思?解决方案三:难道是传说中的&quot;下载&quot;···解决方案四:/// ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bEKv1Zp.html" rel="bookmark" class="title">请问这是什么编程字体</a>
					<div>
						问题描述 请问这是什么编程字体 请问这是什么字体? 解决方案 Monacohttp://www.iplaysoft.com/top10-programming-fonts.html					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bBkgLNM.html" rel="bookmark" class="title">用ASP实现对ORACLE数据库的操作&lowbar;应用技巧</a>
					<div>
						ASP(Active Server Pages)是微软公司为开发互联网应用程序所提出的工具之一,ASP与数据库的联接一般通过ADO(Activex Data Object)来实现的,就象&lt;计算机 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M0Na16z.html" rel="bookmark" class="title">在SQLServer 2005中编写存储过程&lowbar;mssql2005</a>
					<div>
						然而,在SQL Server 2005中,我们可以用.NET家族的语言--主要是VB.NET和C#来编写存储过程(以及方法.触发器和其它组件).让我们来熟悉一下关于编写存储过程新方法的5个常见问题.它 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/boL9gDM.html" rel="bookmark" class="title">asp&period;net下gridview 批量删除的实现方法第1&sol;3页&lowbar;实用技巧</a>
					<div>
						要实现的效果很简单,看下图片: 功能:选中CheckBox,后从数据库中删除选中项.文章侧重将如何实现批量删除,对于如何链接数据库和绑定数据不做详细解释. 1 我们先要在GridView中添加一列为C ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M0N0JJz.html" rel="bookmark" class="title">sqlserver的sql语句转成oracle</a>
					<div>
						问题描述 sqlserver的sql语句转成oracle SELECT FF.*, AF.FUNCGROUPNAME FROM (SELECT F.FUNCCODE,F.FUNCNAME,F.ISME ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MqWPJGz.html" rel="bookmark" class="title">第四范式戴文渊：大数据不再是AI发展瓶颈，未来企业赢在&OpenCurlyDoubleQuote;维度&rdquo; ｜2016 CAIIC</a>
					<div>
						今天大家讨论比较多的人工智能,包括深度学习等这些技术为什么会对我们有帮助?究竟背后在什么地方能够去改变这个世界?在今天于深圳举办的中国人工智能产业大会上,人工智能公司第四范式创始人兼CEO戴文渊就其专 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pLBdJab.html" rel="bookmark" class="title">电子元器件分享3G盛宴</a>
					<div>
						随着3G网络建设的推进,我们于第4季度始将电信应用领域作为首选的投资重点.这一观点在10年投资策略中得以延续. 我们看好电信应用的理由如下:(1)我们预期中国可能用3~5年的时间完成主体用户从2G向3 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b3Ydm0p.html" rel="bookmark" class="title">Java中xml转json的问题，急急急</a>
					<div>
						问题描述 那个..小弟想请教各位大牛一个问题..我今天在网上搜索java的xml转json的方法,后来看到http://www.oschina.net/code/snippet_436266_1197 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zDXo8Bz.html" rel="bookmark" class="title">WEB2&period;0最具代表性的是啥</a>
					<div>
						当然是SNS啦.从博客到推特.非死不可再到谷歌加,无不一次次引领着互联网的潮流.推特和非死不可已经把熟人社交做到极致(好吧,不是推特,是推特的学生新浪),而纵然被称为鬼城,谷歌加不容置疑的发扬壮大了兴 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zen1ANb.html" rel="bookmark" class="title">Windows 10无法更新？仅需一招即可破解</a>
					<div>
						Windows 10 TH2更新不知道大家是否已经升级?从体验看,这个综合性的&quot;大补丸&quot;还是十分给力的,带来了不少用户呼声很高的新特性,完善了UI界面,性能也有了全方位的提升,流畅 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bBG1ZAM.html" rel="bookmark" class="title">南京市新闻发言人曹劲松：删帖并不是好办法</a>
					<div>
						随着互联网的快速发展,地方网络论坛已经成为本地公众表达民意的活跃空间.有专家认为,地方论坛也由此变成政府疏导民意的最直接路径.但事实上,很多地方论坛并未达到这一目标.究其原因,是一些地方政府一味删帖, ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 11 q. 0.038 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
